---
title: 'ARIA: textbox role'
slug: Web/Accessibility/ARIA/Roles/textbox_role
tags:
  - ARIA
  - Accessibility
  - NeedsContent
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p><span class="seoSummary">The <code>textbox</code> role is used to identify an element that allows the input of free-form text. </span>Whenever possible, rather than using this role, use an {{HTMLElement("input")}} element with <a href="/en-US/docs/Web/HTML/Element/input/text">type="text"</a>, for single-line input, or a {{HTMLElement("textarea")}} element for multi-line input.</p>

<h2 id="Description">Description</h2>

<p class="p2">When an element has the <code>textbox</code> role, the browser sends an accessible textbox event to assistive technologies, which can then notify the user about it.</p>

<p class="p2">The default is a single line input, in which <kbd>Return</kbd> or <kbd>Enter</kbd> submits the form; in this case, it is preferable to use an HTML {{HTMLElement("input")}} with <code>type="text"</code>. To create a multi-line text box which supports line breaks, as in an HTML {{HTMLElement("textarea")}}, set <code><span class="s1">aria-multiline="true"</span></code>. Including the HTML <code>contenteditable</code> attribute ensures the text node is editable.</p>

<pre class="brush: html">&lt;!-- Simple text input field --&gt;
&lt;div id="txtboxLabel"&gt;Enter your five-digit zipcode&lt;/div&gt;
&lt;div role="textbox" contenteditable="true" aria-placeholder="5-digit zipcode" aria-labelledby="txtboxLabel"&gt;&lt;/div&gt;

&lt;!-- Multi-line text area --&gt;
&lt;div id="txtboxMultilineLabel"&gt;Enter the tags for the article&lt;/div&gt;
&lt;div role="textbox" contenteditable="true" aria-multiline="true"
   aria-labelledby="txtboxMultilineLabel" aria-required="true"&gt;&lt;/div&gt; </pre>

<p>Semantic elements are more concise and require no JavaScript to support textbox features.</p>

<pre class="brush: html">&lt;label for="txtbox"&gt;Enter your five-digit zipcode&lt;/label&gt;
&lt;input type="text" placeholder="5-digit zipcode" id="txtbox"/&gt;

&lt;!-- Multi-line text area --&gt;
&lt;label for="txtboxMultiline"&gt;Enter the tags for the article&lt;/label&gt;
&lt;textarea id="txtboxMultiline" required&gt;&lt;/textarea&gt; </pre>

<p class="p2">Where a text field is read-only, indicated this by setting <code><span class="s1">aria-readonly="true"</span></code> on the element.</p>

<h3 class="highlight-spanned" id="Associated_ARIA_properties"><span class="highlight-span">Associated ARIA properties</span></h3>

<dl>
	<dt><code>aria-activedescendent</code> attribute</dt>
	<dd>Taking as it's value the ID of is either a descendant of the element with DOM focus or is a logical descendant as indicated by the <code>aria-owns</code> attribute, it indicates when that element has focus, when it is part of a composite widget such as a <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/combobox">combobox</a>. For example, in a combobox, focus may remain on the textbox while the value of <code>aria-activedescendant</code> on the textbox element refers to a descendant of a popup listbox that is controlled by the textbox.This attribute must be updated programmatically as the focus changes.</dd>
	<dt><code>aria-autocomplete</code> attribute</dt>
	<dd>Indicates whether and how the user's input into the field could trigger display of a prediction of the intended value. It supports the following values:
	<ul>
		<li><code>inline</code>: Predicted text is inserted after the caret.</li>
		<li><code>list</code>: Predicted text is presented as a collection of values.</li>
		<li><code>both</code>: Predicted text is presented as a collection of values, with the text needed to complete one value inserted after the caret.</li>
		<li><code>none</code> (default): Predicted text is not offered.</li>
	</ul>

	<p>If list or both is set, the <code>aria-controls</code> and <code>aria-haspopup</code> attributes should also be included. The value of <code>aria-controls</code> is the ID of the element that contains the list of suggested values. Additionally, either the textbox or a containing element with role <code>combobox</code> has a value for <code>aria-haspopup</code> that matches the role of the element that contains the list of suggested values.</p>
	</dd>
	<dt><code>aria-multiline</code> attribute</dt>
	<dd>If <code>aria-multiline="true</code>" is set, the AT informs the user that the textbox supports multi-line input, with the expectation that <kbd>Enter</kbd>  or <kbd>Return</kbd> will create a line break rather than submitting the form. ARIA does not alter the behavior of the element; rather this feature must be controlled by the developer. If false is set, or the attribute is omitted and defaults to false, the user expectation is that the control is a single line text box, and <kbd>Enter</kbd>  or <kbd>Return</kbd> submits the form.</dd>
	<dt><code>aria-placeholder</code> attribute</dt>
	<dd>Represents a hint (word or phrase) to the user about what to enter into the text field. The hint should be a sample value or a brief description of the expected format.This information should not be used as a substitute for a label: a label is focusable, permanent, indicates what kind of information is expected, and increases the hit area for setting focus on the control, whereas placeholder text is only temporary hint about the expected value, which if implemented incorrectly can decrease accessibility. The placeholder should be visible when the control's value is the empty string such as when the control first receives focus and when users remove a previously-entered value. Instead of using <code>aria-placeholder</code>, use the semantic <code>&lt;input type="text"&gt;</code> or <code>&lt;textarea&gt;</code> with a <code>placeholder</code> attribute.</dd>
	<dt><code>aria-readonly</code> attribute</dt>
	<dd>Indicates that the user cannot modify the value of the text field. Instead of using <code>aria-readonly</code>, use the semantic <code>&lt;input type="text"&gt;</code> or <code>&lt;textarea&gt;</code> with a <code>readonly</code> attribute.</dd>
	<dt><code>aria-required</code> attribute</dt>
	<dd>Indicates that a value must be provided for the field before it is submitted. Instead of using <code>aria-required</code>, use the semantic <code>&lt;input type="text"&gt;</code> or <code>&lt;textarea&gt;</code> with a <code>required</code> attribute.</dd>
</dl>

<h3 class="highlight-spanned" id="Keyboard_interactions"><span class="highlight-span">Keyboard interactions</span></h3>

<p>In a single-line use (when <code>aria-multiline</code> is <code>false</code> or not used), the Return or Enter key submits the form. In a multi-line use (when <code>aria-multiline</code> is <code>true</code>), Return or Enter key inserts a line break.</p>

<h3 class="highlight-spanned" id="JavaScript_features"><span class="highlight-span">JavaScript features</span></h3>

<p><span class="highlight-span">All features associated with any and all properties and states must be maintained, and forms submission on enter or return on a single line textbox needs to be handled.</span></p>

<dl>
	<dt>Focus event handler and aria-activedescendent attribute</dt>
	<dd>If you are implementing a composite widget, such as a combobox composed of a text box and a listbox, you need to manage the <code>aria-activedescendent</code> attribute using a handler. Before using this technique, ensure that the browsers you need to target currently support it. See the <a href="https://www.w3.org/TR/wai-aria-1.1/#aria-activedescendant">specification of aria-descendent</a> for further information.</dd>
</dl>

<div class="note">
<p><span class="ILfuVd yZ8quc">It is a better practice to use an {{HTMLElement("input")}} element with type="text", or a {{HTMLElement("textarea")}} element instead of the ARIA textbox role. When using either semantic element, the ARIA textbox role is not necessary. </span>See <a href="https://www.w3.org/TR/aria-in-html/">Notes on Using ARIA in HTML</a>.</p>
</div>

<h2 id="Possible_effects_on_user_agents_and_assistive_technology">Possible effects on user agents and assistive technology </h2>

<p class="p1">When the <code>textbox</code> role is added to an element, or such an element becomes visible, the user agent should do the following:</p>

<ul class="ul1">
	<li class="li2">Expose the element as having a textbox role in the operating system's accessibility API.</li>
	<li class="li2">Fire an accessible textbox event using the operating system's accessibility API if it supports it.</li>
</ul>

<p class="p1">Assistive technology products should listen for such an event and notify the user accordingly:</p>

<ul class="ul1">
	<li class="li2">Screen readers should announce its label and role when focus first lands on a textbox. If it also contains content, this should be announced as with a regular textbox.</li>
	<li class="li2">Screen magnifiers may enlarge the textbox.</li>
</ul>

<div class="note"><strong>Note:</strong> Opinions may differ on how assistive technology should handle this technique. The information provided above is one of those opinions and therefore not normative.</div>

<h2 id="Examples">Examples</h2>

<h3 id="Example_1_Adding_the_role_in_the_HTML_code_for_single_line_input">Example 1: Adding the role in the HTML code for single line input</h3>

<p class="p2">The snippet below shows how the textbox role is added directly into the HTML source code.</p>

<pre class="brush: html">&lt;div role="textbox" contenteditable="true"&gt;&lt;/div&gt;</pre>

<h3 class="p1" id="Example_2_Adding_the_role_in_the_HTML_code_for_multi-line_input">Example 2: Adding the role in the HTML code for multi-line input</h3>

<p class="p2">The snippet below shows how the textbox role is added directly into the HTML source code.</p>

<pre class="brush: html">&lt;div role="textbox" contenteditable="true" aria-multiline="true"&gt;&lt;/div&gt;</pre>

<h2 id="Best_practices">Best practices</h2>

<ul>
	<li class="li1">Be sure to add the <code>contenteditable="true"</code> attribute to the HTML element to which this role is applied. Do so even if you set <code>aria-readonly</code> to <code>true</code>; in this way, you communicate that the content would be editable if it were not read-only.</li>
</ul>

<h2 id="See_Also">See Also</h2>

<ul>
	<li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/searchbox">ARIA: search role</a></li>
</ul>
